#ifndef __3DMATH

#define __3DMATH

#ifdef _WIN32
#include <windows.h>
#else
#include "wintypes.h"
#endif
#include <math.h>

typedef float MATRIX3[9];
typedef float MATRIX4[16];
typedef float VFLOAT;
typedef	float VECTOR[4];

extern void PrintMatrix4(MATRIX4 Matrix);
extern void PrintVector(VECTOR vec);
extern void PrintFloat(float f);

extern void m4_submat( MATRIX4 mr, MATRIX3 mb, int i, int j );
extern VFLOAT m4_det( MATRIX4 mr );
extern int m4_inverse( MATRIX4 mr, MATRIX4 ma );
extern int m3_inverse( MATRIX4 mr, MATRIX4 ma );
extern VFLOAT m3_det( MATRIX3 mat );

extern void TranformVector(float *src, float *dst, MATRIX4 mat);
extern void transform_vector2(float * vd,float x0,float y0,float z0,float w0);
extern void project_vector(float * vd,float x0,float y0,float z0);
extern void NormalizeVector(float *v);

extern float DotProduct(float *v1, float *v2);
extern void CrossProduct(float *v1, float *v2, float *v3);
extern BOOL compare_matrix4(MATRIX4 m1, MATRIX4 m2);

extern float VectorLength(float *v);
extern void transform_vector(float * vd,float x0,float y0,float z0);
extern void transform_normal(float * vd);
extern void project_vector(float * vd,float x0,float y0,float z0);
extern void project_vector2(float *vd);
extern void push_matrix(void);
extern void pop_matrix(void);
extern void load_matrix(float * m);
extern void mult_matrix(float * m);
extern void load_prj_matrix(float * m);
extern void mult_prj_matrix(float * m);
extern void get_matrix(float * m);
extern void push_mult_matrix(float * m);
extern void push_load_matrix(float * m);

extern void reflect_vector(float *v,float *n,float *r);

extern void calculate_light_vectors();
extern void math_lighting(t_vtx_tn *vtx, float color[4]);

#endif
