#ifndef __SDLGL_H__
#define __SDLGL_H__

#include "SDL.h"
#include "wintypes.h"

typedef struct
{
	int		width;		// width of the window
	int		height;		// height of the window

	int		xres;			// horizontal resolution (for framebuffer)
	int		yres;			// vertital resolution (for framebuffer)

	char	rbpp;   // requested depth
	char	ubpp;   // actaul used depth, we don't need alpha atm
	char	active; // whether we have a current mode

	struct {
//		char		antialiasing;
		int	gleGL_POINT_SMOOTH_HINT,
				gleGL_LINE_SMOOTH_HINT,
				gleGL_POLYGON_SMOOTH_HINT,
				gleGL_PERSPECTIVE_CORRECTION_HINT;
	} flags;

	SDL_Surface *screen;	// window surface

} TWindow;

extern TWindow window;
extern const char szAppName[];

/*****************************************************************************/
/* Copiled Displaylists for speedup                                          */
/*****************************************************************************/
#define kListEnd2D          1
#define kListBeginLights	9
#define kListBegin2D160   160
#define kListBegin2D320   320
#define kListBegin2D640   640
#define kListBegin2D800   800
#define kListBegin2D960   960
#define kListBegin2D1024 1024
#define kListBegin2D1200 1200

BOOL CreateDisplayWindow(void);
extern BOOL SDLGL_Init (void);
extern void SDLGL_UnInit (void);

extern void SDLGL_InitState(void);
extern BOOL SDLGL_SwapBuffers(void);

extern void SDLGL_SetViewport(int x, int y);
extern void SDLGL_ToggleFullScreen( void );

#endif
